tests.sh: less hackish way to handle fixme directories for savdirs
[nit.git] / tests / tests.sh
index 9425ce7..6483969 100755 (executable)
 
 # Set lang do default to avoid failed tests because of locale
 export LANG=C
+export NIT_TESTING=true
+
+unset NIT_DIR
+
+# Get the first Java lib available
+shopt -s nullglob
+paths=`echo /usr/lib/jvm/*/`
+paths=($paths) 
+JAVA_HOME=${paths[0]}
+
+paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
+paths=($paths) 
+JNI_LIB_PATH=${paths[0]}
+shopt -u nullglob
 
 usage()
 {
        e=`basename "$0"`
        cat<<END
 Usage: $e [options] modulenames
--o option   Pass option to nitc
+-o option   Pass option to the engine
 -v          Verbose (show tests steps)
 -h          This help
+--engine    Use a specific engine (default=nitg)
+--noskip    Do not skip a test even if the .skip file matches
+--[no]soso  Force enable (or disable) SOSO
 END
 }
 
+# $1 is the pattern of the test
+# $2 is the file to compare to
+# the result is:
+#   0: if the file to compare to do not exists
+#   1: if the file match
+#   2: if the file match with soso
+#   3: if the file do not match
+function compare_to_result()
+{
+       local pattern="$1"
+       local sav="$2"
+       if [ ! -r "$sav" ]; then return 0; fi
+       diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
+       if [ "$?" == 0 ]; then
+               return 1
+       fi
+       [ -z "$soso" ] && return 3
+       sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
+       sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
+       grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
+       grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
+       diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
+       if [ "$?" == 0 ]; then
+               return 2
+       else
+               return 3
+       fi
+}
+
 # As argument: the pattern used for the file
 function process_result()
 {
        # Result
        pattern=$1
+       description=$2
+       pack=$3
        SAV=""
-       FAIL=""
+       NSAV=""
+       FIXME=""
+       NFIXME=""
        SOSO=""
+       NSOSO=""
        SOSOF=""
-       if [ -r "sav/$pattern.sav" ]; then
-               diff -u "out/$pattern.res" "sav/$pattern.sav" > "out/$pattern.diff.sav.log"
-               if [ "$?" == 0 ]; then
-                       SAV=OK
-               else
-                       SAV=NOK
-               fi
-               sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-               sed '/[Ww]arning/d;/[Ee]rror/d' "sav/$pattern.sav" > "out/$pattern.sav2"
-               grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-               grep '[Ee]rror' "sav/$pattern.sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
-               diff -u "out/$pattern.res2" "out/$pattern.sav2" > "out/$pattern.diff.sav2.log"
-               if [ "$?" == 0 ]; then
-                       SOSO=OK
-               else
-                       SOSO=NOK
-               fi
-       fi
-       if [ -r "sav/$pattern.fail" ]; then
-               diff -u "out/$pattern.res" "sav/$pattern.fail" > "out/$pattern.diff.fail.log"
-               if [ "$?" == 0 ]; then
-                       FAIL=OK
-               else
-                       FAIL=NOK
-               fi
-               sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
-               sed '/[Ww]arning/d;/[Ee]rror/d' "sav/$pattern.fail" > "out/$pattern.fail2"
-               grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
-               grep '[Ee]rror' "sav/$pattern.fail" >/dev/null && echo "Error" >> "out/$pattern.fail2"
-               diff -u "out/$pattern.res2" "out/$pattern.fail2" > "out/$pattern.diff.fail2.log"
-               if [ "$?" == 0 ]; then
-                       SOSOF=OK
+       NSOSOF=""
+       OLD=""
+       LIST=""
+       FIRST=""
+       echo >>$xml "<testcase classname='$pack' name='$description'>"
+       #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
+       for savdir in $savdirs; do
+               sav=$savdir/fixme/$pattern.res
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               OLD="$LIST"
+                               FIXME="$sav"
+                               LIST="$LIST $sav"
+                               ;;
+                       2)
+                               SOSOF="$sav"
+                               LIST="$LIST $sav"
+                               ;;
+                       3)
+                               if [ -z "$FIRST" ]; then
+                                       NFIXME="$sav"
+                                       FIRST="$sav"
+                               fi
+                               LIST="$LIST $sav"
+                               ;;
+               esac
+
+               sav=$savdir/$pattern.res
+               compare_to_result "$pattern" "$sav"
+               case "$?" in
+                       0)
+                               ;; # no file
+                       1)
+                               OLD="$LIST"
+                               SAV="$sav"
+                               LIST="$LIST $sav"
+                               ;;
+                       2)
+                               SOSO="$sav"
+                               LIST="$LIST $sav"
+                               ;;
+                       3)
+                               if [ -z "$FIRST" ]; then
+                                       NSAV="$sav"
+                                       FIRST="$sav"
+                               fi
+                               LIST="$LIST $sav"
+                               ;;
+               esac
+       done
+       OLD=`echo "$OLD" | sed -e 's/   */ /g' -e 's/^ //' -e 's/ $//'`
+       grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
+       NYI="$?"
+       if [ -n "$SAV" ]; then
+               if [ -n "$OLD" ]; then
+                       echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
+                       echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
+                       remains="$remains $OLD"
                else
-                       SOSOF=NOK
+                       echo "[ok] out/$pattern.res $SAV"
                fi
-       fi
-       if [ "x$SAV" = "xOK" ]; then
-               if [ "x$FAIL" = "x" ]; then
-                       echo "[ok] out/$pattern.res"
+               ok="$ok $pattern"
+       elif [ -n "$FIXME" ]; then
+               if [ -n "$OLD" ]; then
+                       echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
+                       echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
+                       remains="$remains $OLD"
                else
-                       echo "[ok] out/$pattern.res - but sav/$pattern.fail remains!"
+                       echo "[fixme] out/$pattern.res $FIXME"
+                       echo >>$xml "<skipped/>"
                fi
+               todos="$todos $pattern"
+       elif [ -n "$SOSO" ]; then
+               echo "[soso] out/$pattern.res $SOSO"
                ok="$ok $pattern"
-       elif [ "x$FAIL" = "xOK" ]; then
-               echo "[fail] out/$pattern.res"
-               ok="$ok $pattern"
-       elif [ "x$SOSO" = "xOK" ]; then
-               echo "[soso] out/$pattern.res sav/$pattern.sav"
-               ok="$ok $pattern"
-       elif [ "x$SOSOF" = "xOK" ]; then
-               echo "[fail soso] out/$pattern.res sav/$pattern.fail"
-               ok="$ok $pattern"
-       elif [ "x$SAV" = "xNOK" ]; then
-               echo "[======= fail out/$pattern.res sav/$pattern.sav =======]"
+       elif [ "x$NYI" = "x0" ]; then
+               echo "[todo] out/$pattern.res -> not yet implemented"
+               echo >>$xml "<skipped/>"
+               todos="$todos $pattern"
+       elif [ -n "$SOSOF" ]; then
+               echo "[fixme soso] out/$pattern.res $SOSOF"
+               echo >>$xml "<skipped/>"
+               todos="$todos $pattern"
+       elif [ -n "$NSAV" ]; then
+               echo "[======= fail out/$pattern.res $NSAV =======]"
+               echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
-       elif [ "x$FAIL" = "xNOK" ]; then
-               echo "[======= changed out/$pattern.res sav/$pattern.fail ======]"
+       elif [ -n "$NFIXME" ]; then
+               echo "[======= changed out/$pattern.res $NFIXME ======]"
+               echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
+               echo >>$xml "]]></system-out>"
                nok="$nok $pattern"
                echo "$ii" >> "$ERRLIST"
-       else
-               echo "[=== no sav ===] out/$pattern.res"
+       elif [ -s out/$pattern.res ]; then
+               echo "[=== no sav ===] out/$pattern.res is not empty"
+               echo >>$xml "<error message='no sav and not empty'/>"
+               echo >>$xml "<system-out><![CDATA["
+               cat -v >>$xml out/$pattern.res
+               echo >>$xml "]]></system-out>"
                nos="$nos $pattern"
+       else
+               # no sav but empty res
+               echo "[0k] out/$pattern.res is empty"
+               ok="$ok $pattern"
+       fi
+       if test -s out/$pattern.cmp.err; then
+               echo >>$xml "<system-err><![CDATA["
+               cat -v >>$xml out/$pattern.cmp.err
+               echo >>$xml "]]></system-err>"
        fi
+       echo >>$xml "</testcase>"
 }
 
-find_nitc()
+need_skip()
 {
-       recent=`ls -t ../src/nitc ../src/nitc_[0-9] ../bin/nitc ../c_src/nitc 2>/dev/null | head -1`
-       if [[ "x$recent" == "x" ]]; then
-               echo 'Could not find nitc, aborting'
-               exit 1
+       test "$noskip" = true && return 1
+       if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
+               echo "=> $2: [skip]"
+               echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
+               return 0
        fi
-       echo 'Using nitc from: '$recent
-       NITC=$recent
+       if test $engine = niti && echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
+               echo "=> $2: [skip exec]"
+               echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
+               return 0
+       fi
+       return 1
 }
 
-make_alts0()
+skip_exec()
 {
-       ii="$1"
-       xalt="$2"
-       fs=""
-       for alt in `sed -n "s/.*#!*\($xalt[0-9]*\)#.*/\1/p" "$ii" | sort -u`; do
-               f=`basename "$ii" .nit`
-               d=`dirname "$ii"`
-               ff="$f"
-               i="$ii"
-
-               if [ "x$alt" != "x" ]; then
-                       test -d alt || mkdir -p alt
-                       i="alt/${f}_$alt.nit"
-                       ff="${ff}_$alt"
-                       sed "s/#$alt#//g;/#!$alt#/d" "$ii" > "$i"
-               fi
-               ff="$ff$MARK"
-               fs="$fs $i"
-       done
-       echo "$fs"
+       test "$noskip" = true && return 1
+       if echo "$1" | grep -f "exec.skip" >/dev/null 2>&1; then
+               echo -n "_ "
+               return 0
+       fi
+       return 1
 }
-make_alts()
+
+skip_cc()
 {
-       ii="$1"
-       fs="$1"
-       for xalt in `sed -n 's/.*#!*\([0-9]*alt\)[0-9]*#.*/\1/p' "$ii" | sort -u`; do
-               fs2=""
-               for f in $fs; do
-                       fs2="$fs2 `make_alts0 $f $xalt`"
-               done
-               fs="$fs $fs2"
-       done
-       echo "$fs"
+       test "$noskip" = true && return 1
+       if echo "$1" | grep -f "cc.skip" >/dev/null 2>&1; then
+               return 0
+       fi
+       return 1
 }
 
-# The default nitc compiler
-[ -z "$NITC" ] && find_nitc
-
-# Set NIT_DIR if needed
-[ -z "$NIT_DIR" ] && export NIT_DIR=..
+find_nitc()
+{
+       name="$enginebinname"
+       recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
+       if [[ "x$recent" == "x" ]]; then
+               echo "Could not find binary for engine $engine, aborting"
+               exit 1
+       fi
+       echo "Find binary for engine $engine: $recent $OPT"
+       NITC=$recent
+}
 
 verbose=false
 stop=false
+engine=nitg
+noskip=
+savdirs=
 while [ $stop = false ]; do
        case $1 in
                -o) OPT="$OPT $2"; shift; shift;;
                -v) verbose=true; shift;;
                -h) usage; exit;;
+               --engine) engine="$2"; shift; shift;;
+               --noskip) noskip=true; shift;;
+               --soso) soso=true; shift;;
+               --nososo) nososo=true; shift;;
                *) stop=true
        esac
 done
+enginebinname=$engine
+case $engine in
+       nitg)
+               engine=nitg-s;
+               enginebinname=nitg;
+               OPT="--separate $OPT"
+               ;;
+       nitg-s)
+               enginebinname=nitg;
+               OPT="--separate $OPT"
+               ;;
+       nitg-e)
+               enginebinname=nitg;
+               OPT="--erasure $OPT"
+               ;;
+       nitg-g)
+               enginebinname=nitg;
+               OPT="--global $OPT"
+               ;;
+       nit)
+               engine=niti
+               ;;
+       niti)
+               enginebinname=nit
+               ;;
+       nitc)
+               echo "disabled engine $engine"
+               exit 0
+               ;;
+       *)
+               echo "unknown engine $engine"
+               exit 1
+               ;;
+esac
+
+savdirs="sav/$engine $savdirs sav/"
+
+# The default nitc compiler
+[ -z "$NITC" ] && find_nitc
+
+# Set NIT_DIR if needed
+[ -z "$NIT_DIR" ] && export NIT_DIR=..
+
+if sh -c "timelimit echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timelimit -t 600"
+elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
+       TIMEOUT="timeout 600s"
+else
+       echo "No timelimit or timeout command detected. Tests may hang :("
+fi
 
 # Mark to distinguish files among tests
 # MARK=
@@ -193,6 +351,9 @@ fi
 
 ok=""
 nok=""
+todos=""
+xml="tests-$engine.xml"
+echo >$xml "<testsuites><testsuite>"
 
 # CLEAN the out directory
 rm -rf out/ 2>/dev/null
@@ -203,6 +364,12 @@ for ii in "$@"; do
                echo "File '$ii' does not exist."
                continue
        fi
+       f=`basename "$ii" .nit`
+
+       pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
+
+       # Sould we skip the file for this engine?
+       need_skip $f $f $pack && continue
 
        tmp=${ii/../AA}
        if [ "x$tmp" = "x$ii" ]; then
@@ -211,10 +378,13 @@ for ii in "$@"; do
                includes="-I alt"
        fi
 
-       f=`basename "$ii" .nit`
-       for i in `make_alts $ii`; do
+       for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
                bf=`basename $i .nit`
                ff="out/$bf"
+
+               # Sould we skip the alternative for this engine?
+               need_skip $bf $bf $pack && continue
+
                echo -n "=> $bf: "
 
                if [ -f "$f.inputs" ]; then
@@ -223,32 +393,56 @@ for ii in "$@"; do
                        inputs=/dev/null
                fi
 
-               # Compile
-               if [ "x$verbose" = "xtrue" ]; then
-                       echo ""
-                       echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
-               fi
-               $NITC --no-color $OPT -o "$ff.bin" "$i" $includes <"$inputs" 2> "$ff.cmp.err" > "$ff.compile.log"
-               ERR=$?
-               if [ "x$verbose" = "xtrue" ]; then
-                       cat "$ff.compile.log"
-                       cat >&2 "$ff.cmp.err"
+               if [ "$engine" = "niti" ]; then
+                       cat > "./$ff.bin" <<END
+exec $NITC --no-color $OPT "$i" $includes -- "\$@"
+END
+                       chmod +x "./$ff.bin"
+                       > "$ff.cmp.err"
+                       > "$ff.compile.log"
+                       ERR=0
+               else
+                       if skip_cc "$bf"; then
+                               nocc="--no-cc"
+                       else
+                               nocc=
+                       fi
+                       # Compile
+                       if [ "x$verbose" = "xtrue" ]; then
+                               echo ""
+                               echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes" $nocc
+                       fi
+                       NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
+                               $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes $nocc 2> "$ff.cmp.err" > "$ff.compile.log"
+                       ERR=$?
+                       if [ "x$verbose" = "xtrue" ]; then
+                               cat "$ff.compile.log"
+                               cat >&2 "$ff.cmp.err"
+                       fi
                fi
-               egrep '^[A-Z0-9_]*$' "$ff.compile.log" > "$ff.res"
                if [ "$ERR" != 0 ]; then
                        echo -n "! "
-                       cat "$ff.cmp.err" "$ff.compile.log" > "$ff.res"
-                       process_result $bf
+                       cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
+                       process_result $bf $bf $pack
+               elif skip_exec "$bf"; then
+                       # No exec
+                       > "$ff.res"
+                       process_result $bf $bf $pack
+               elif [ -n "$nocc" ]; then
+                       # not compiled
+                       echo -n "nocc "
+                       > "$ff.res"
+                       process_result $bf $bf $pack
                elif [ -x "./$ff.bin" ]; then
-                       cp "$ff.cmp.err" "$ff.res"
                        echo -n ". "
                        # Execute
                        args=""
                        if [ "x$verbose" = "xtrue" ]; then
                                echo ""
                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
-                       fi
-                       NIT_NO_STACK=1 "./$ff.bin" $args < "$inputs" >> "$ff.res" 2>"$ff.err"
+                       fi      
+                       NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
+                               $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
                        if [ "x$verbose" = "xtrue" ]; then
                                cat "$ff.res"
                                cat >&2 "$ff.err"
@@ -258,10 +452,9 @@ for ii in "$@"; do
                        elif [ -d "$ff.write" ]; then
                                LANG=C /bin/ls -F $ff.write >> "$ff.res"
                        fi
-                       if [ -s "$ff.err" ]; then
-                               cat "$ff.err" >> "$ff.res"
-                       fi
-                       process_result $bf
+                       cp "$ff.res"  "$ff.res2"
+                       cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
+                       process_result $bf $bf $pack
 
                        if [ -f "$f.args" ]; then
                                fargs=$f.args
@@ -271,13 +464,27 @@ for ii in "$@"; do
                                        args="$line"
                                        bff=$bf"_args"$cptr
                                        fff=$ff"_args"$cptr
+                                       name="$bf args $cptr"
+
+                                       # Sould we skip the input for this engine?
+                                       need_skip $bff "  $name" $pack && continue
+
+                                       # use a specific inputs file, if required
+                                       if [ -f "$bff.inputs" ]; then
+                                               ffinputs="$bff.inputs"
+                                       else
+                                               ffinputs=$inputs
+                                       fi
+
                                        rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
                                        if [ "x$verbose" = "xtrue" ]; then
                                                echo ""
                                                echo "NIT_NO_STACK=1 ./$ff.bin" $args
                                        fi
-                                       echo -n "==> args #"$cptr " "
-                                       sh -c "NIT_NO_STACK=1 ./$ff.bin  ''$args < $inputs > $fff.res 2>$fff.err"
+                                       echo -n "==> $name "
+                                       echo "./$ff.bin $args" > "./$fff.bin"
+                                       chmod +x "./$fff.bin"
+                                       WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
                                        if [ "x$verbose" = "xtrue" ]; then
                                                cat "$fff.res"
                                                cat >&2 "$fff.err"
@@ -288,21 +495,26 @@ for ii in "$@"; do
                                                LANG=C /bin/ls -F $fff.write >> "$fff.res"
                                        fi
                                        if [ -s "$fff.err" ]; then
-                                               cat "$fff.err" >> "$fff.res"
+                                               cp "$fff.res"  "$fff.res2"
+                                               cat "$fff.err" "$fff.res2" > "$fff.res"
                                        fi
-                                       process_result $bff
+                                       process_result $bff "  $name" $pack
                                done < $fargs
                        fi
+               elif [ -f "./$ff.bin" ]; then
+                       echo "Not executable (platform?)" > "$ff.res"
+                       process_result $bf "$bf" $pack
                else
                        echo -n "! "
-                       cat "$ff.cmp.err" "$ff.compile.log" > "$ff.res"
-                       #echo "Compilation error" > "$ff.res"
-                       process_result $bf
+                       cat "$ff.cmp.err" > "$ff.res"
+                       echo "Compilation error" > "$ff.res"
+                       process_result $bf "$bf" $pack
                fi
        done
 done
 
-echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos | wc -w`
+echo "engine: $engine ($enginebinname $OPT)"
+echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
 
 if [ -n "$nok" ]; then
        echo "fail: $nok"
@@ -311,6 +523,12 @@ fi
 if [ -n "$nos" ]; then
        echo "no sav: $nos"
 fi
+if [ -n "$todos" ]; then
+       echo "todo/fixme: $todos"
+fi
+if [ -n "$remains" ]; then
+       echo "sav that remains: $remains"
+fi
 
 # write $ERRLIST
 if [ "x$ERRLIST" != "x" ]; then
@@ -320,6 +538,8 @@ if [ "x$ERRLIST" != "x" ]; then
        mv $ERRLIST $ERRLIST_TARGET
 fi
 
+echo >>$xml "</testsuite></testsuites>"
+
 if [ -n "$nok" ]; then
        exit 1
 else